package org.processmining.plugins.properties.conversion;

import java.util.HashMap;
import java.util.UUID;

import org.processmining.framework.util.Pair;
import org.processmining.plugins.properties.processmodel.impl.Distribution;
import org.processmining.plugins.properties.processmodel.impl.TaskDistribution;

/**
 * 
 * @author DSchunse
 *
 */
public class YerkesDodsonInterval2TaskDistribution {

	/**
	 * Helper function since not that many tools support Yerkes-Dodson, we convert it to a conventional distribution.
	 * For now, we just take the first distribution we can find :-)
	 * @param yerkesDodsen
	 * @return
	 */
	@SuppressWarnings("unchecked")
	public static TaskDistribution convert(Object yerkesDodson){
		HashMap<UUID, HashMap<Pair<Double, Double>, Distribution>> yD = (HashMap<UUID, HashMap<Pair<Double, Double>, Distribution>>) yerkesDodson;
		for(UUID id: yD.keySet()){
			for(Pair<Double, Double> interval: yD.get(id).keySet()){
				return new TaskDistribution(yD.get(id).get(interval));
			}
		}
		return new TaskDistribution();
		
	}

}
