package org.processmining.plugins.properties.processmodel.abstractproperty;

import java.util.ArrayList;
import java.util.List;

import org.processmining.plugins.properties.processmodel.TimeValue;
import org.processmining.plugins.properties.processmodel.gui.GUIProperty;
import org.processmining.plugins.properties.processmodel.gui.impl.GUIPropertyListTimeValue;

/**
 * 
 * @author DSchunse
 *
 */
@SuppressWarnings("serial")
public abstract class PropertyListTimeValue extends PropertyList<TimeValue>{
	public Object unmarshall(String xml){
		List<TimeValue> ret = new ArrayList<TimeValue>();
		// we have a string with valueEntries
		String[] values = xml.split("<valueEntry value=\"");
		for(String s: values){
			if(!s.split("\"")[0].isEmpty()){
				TimeValue timeVal = new TimeValueImpl();
				timeVal.valueOf(s.split("\"")[0]);
				ret.add(timeVal);
			}
		}
		return ret;
	}
	
	public GUIProperty<List<TimeValue>> getGUIProperty() throws InstantiationException, IllegalAccessException {
		return GUIPropertyListTimeValue.class.newInstance();
	}
	
	@SuppressWarnings("unchecked")
	public List<TimeValue> clone(Object element){
		List<TimeValue> elem = (List<TimeValue>) element;
		List<TimeValue> ret = new ArrayList<TimeValue>();
		for(TimeValue tv: elem){
			ret.add(new TimeValueImpl(tv));
		}
		return ret;
	}
}
