package org.processmining.plugins.properties.processmodel.abstractproperty;

import java.util.HashMap;
import java.util.Map;

/**
 * 
 * @author DSchunse
 *
 */
@SuppressWarnings("serial")
public abstract class PropertyMapDoubleDouble extends HighLevelProperty<Map<Double, Double>>{
	@SuppressWarnings("unchecked")
	public String marshall(Object values){
		Map<Double, Double> value = (HashMap<Double, Double>) values;
		String ret = "";
		for(Double key: value.keySet()){
			ret += "<valueEntry key=\"" + key + "\" value=\"" + value.get(key) + "\" />\n"; 
		}
		return ret;
	}
	
	public Object unmarshall(String xml){
		Map<Double, Double> values = new HashMap<Double, Double>();
		// we have a set of <value things
		String[] valueString = xml.split("<valueEntry");
		for(String s: valueString){
			if(!s.isEmpty()){
				double key = Double.valueOf(s.substring(s.indexOf("\"") + 1, s.indexOf("\"", s.indexOf("\"") + 1)));
				String valueStr = s.split("value")[1];
				double value = Double.valueOf(valueStr.substring(valueStr.indexOf("\"") + 1, valueStr.indexOf("\"", valueStr.indexOf("\"") + 1)));
				values.put(key, value);
			}
		}
		return values;
	}
	
	@SuppressWarnings("unchecked")
	public Map<Double, Double> clone(Object element){
		Map<Double, Double> elem = (Map<Double, Double>) element;
		Map<Double, Double> ret = new HashMap<Double, Double>();
		for(Double d: elem.keySet()){
			ret.put(new Double(d), new Double(elem.get(d)));
		}
		return ret;
	}

}
