package org.processmining.plugins.properties.processmodel.configurable;

import java.util.Collections;

/**
 * 
 * @author DSchunse
 *
 * @param <K>
 */
public class ConfigurablePropertyConfiguration<K> {
	private K removed;
	private K nonRemoved;
	
	public ConfigurablePropertyConfiguration(){
		this(null, null);
	}
	
	public ConfigurablePropertyConfiguration(K removed, K nonRemoved){
		this.setRemoved(removed);
		this.setNonRemoved(nonRemoved);
	}
	
	@SuppressWarnings("unchecked")
	public K getRemoved() {
		if(removed != null){
			return removed;
		}
		else{
			// just make a list out of it (will work in most cases)
			return (K) Collections.emptyList();
		}
	}
	
	public void setRemoved(K removed) {
		this.removed = removed;
	}
	
	@SuppressWarnings("unchecked")
	public K getNonRemoved() {
		if(nonRemoved != null){
			return nonRemoved;
		}
		else{
			// just make a list out of it (will work in most cases)
			return (K) Collections.emptyList();
		}
	}
	
	public void setNonRemoved(K nonRemoved) {
		this.nonRemoved = nonRemoved;
	}
}
