package org.processmining.plugins.properties.processmodel.configurable;

import java.util.List;
import java.util.Map;

import org.processmining.framework.util.Pair;

/**
 * 
 * @author DSchunse
 *
 * @param <K>
 */
public interface ConfigurablePropertyIterator<K> {
	@Deprecated
	ConfigurablePropertyIterator<K> createIterator(ConfigurableProperty<K> configurableProperty, Pair<K, K> values);
	@Deprecated
	ConfigurablePropertyIterator<K> createIterator(ConfigurableProperty<K> configurableProperty, Pair<K, K> values, boolean total);
	
	/**
	 * 
	 * @param configurableProperty
	 * @param values
	 * @param dependentProperties: the other (in)dependent properties of a propertable element
	 * @return
	 */
	ConfigurablePropertyIterator<K> createIterator(ConfigurableProperty<K> configurableProperty, Pair<K, K> values, Map<Class<? extends ConfigurableProperty<?>>, ?> dependentProperties);
	
	/**
	 * 
	 * @param configurableProperty
	 * @param values
	 * @param total
	 * @param dependentProperties: the other (in)dependent properties of a propertable element
	 * @return
	 */
	ConfigurablePropertyIterator<K> createIterator(ConfigurableProperty<K> configurableProperty, Pair<K, K> values, boolean total, Map<Class<? extends ConfigurableProperty<?>>, ?> dependentProperties);
	/**
	 * This function determines if there is another configuration
	 * @return
	 * @throws Exception
	 */
	boolean hasNext() throws Exception;
	
	/**
	 * Return the next configuration
	 * @return
	 * @throws Exception
	 */
	ConfigurablePropertyConfiguration<K> getNext() throws Exception;
	
	/**
	 * Resets the iterator to the initial state
	 */
	void reset();
	
	/**
	 * Return a subdivision of the search space which can be used to distribute the iteration through the 
	 * @return
	 * @throws Exception
	 */
	List<Pair<Object, Object>> getSubdivisions(int divisions) throws Exception;
}
