package org.processmining.plugins.properties.processmodel.gui.abstractguiproperty;

import info.clearthought.layout.TableLayout;

import java.awt.Component;
import java.awt.event.ActionEvent;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import javax.swing.AbstractAction;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JLabel;

import org.processmining.plugins.properties.processmodel.PropertableElement;
import org.processmining.plugins.properties.processmodel.Property;
import org.processmining.plugins.properties.processmodel.gui.GUIProperty;
import org.processmining.plugins.properties.processmodel.gui.impl.GUIHelperFunction;

import com.fluxicon.slickerbox.components.SlickerTabbedPane;
import com.fluxicon.slickerbox.factory.SlickerFactory;

/**
 * 
 * @author DSchunse
 *
 */
public class AddButton extends AbstractAction{

	private static final long serialVersionUID = 1L;
	private PropertableElement element;
	private GUIProperty<?> guiProperty;
	private Property<?> property;
	private Boolean independent;
	private SlickerTabbedPane tabPane;
	private List<List<JComponent>> dataRows;
	protected List<List<List<Object>>> lines;
	HashMap<DeleteButton, List<Integer>> indices;
	protected int header;
	protected boolean editable;
	
	public AddButton(SlickerTabbedPane tabPane, List<List<JComponent>> dataRows, List<List<List<Object>>> lines, HashMap<DeleteButton, List<Integer>> indices, int header, boolean editable) {
		this(null, null, null, null, tabPane, dataRows, lines, indices, header, editable);
	}
	
	public AddButton(PropertableElement element, GUIProperty<?> guiProperty, Property<?> property, Boolean indepenent, SlickerTabbedPane tabPane, List<List<JComponent>> dataRows, List<List<List<Object>>> lines, HashMap<DeleteButton, List<Integer>> indices, int header, boolean editable) {
		this.element = element;
		this.guiProperty = guiProperty;
		this.property = property;
		this.independent = indepenent;
		this.tabPane = tabPane;
		this.dataRows = dataRows;
		this.lines = lines;
		this.indices = indices;
		this.header = header;
		this.editable = editable;
	}
	
	public void actionPerformed(ActionEvent arg0) {
		if(!this.isEnabled()){
			return;
		}
		List<List<Object>> lineGroup = new ArrayList<List<Object>>();
		for(List<JComponent> dataRow: dataRows){
			List<Object> line = new ArrayList<Object>();
			// parse the stuff
			for(JComponent comp: dataRow){
				line.add(GUIHelperFunction.getValue(comp));
			}
			lineGroup.add(line);
		}
		lines.add(lineGroup);
		// now make the labels
		int x = 0;
		int y = 0;
		List<Component> delComp = new ArrayList<Component>();
		for(List<JComponent> dataRow: dataRows){
			int size = ((TableLayout)tabPane.getLayout()).getNumRow();
			x = 0;
			y = size;
			((TableLayout)tabPane.getLayout()).insertRow(size, 30);
			for(JComponent comp: dataRow){
				JLabel lab = SlickerFactory.instance().createLabel(GUIHelperFunction.getValue(comp).toString());
				tabPane.add(lab, "" + x + ", " + size + ", " + x + ", " + size + ", l, c");
				delComp.add(lab);
				x++;
			}
		}
		JButton delete = SlickerFactory.instance().createButton("Delete");
		delComp.add(delete);
		DeleteButton delb = new DeleteButton(element, guiProperty, property, independent, tabPane, lines, lineGroup, indices, delComp, header);
		delete.addActionListener(delb);
		delete.setEnabled(editable);
		tabPane.add(delete, "" + x + ", " + y + ", " + x + ", " + y + ", l, c");
		tabPane.revalidate();
		if(tabPane.getParent() != null){
			tabPane.getParent().invalidate();
			tabPane.getParent().repaint();
			if(tabPane.getParent().getParent() != null){
				tabPane.getParent().getParent().invalidate();
				tabPane.getParent().getParent().repaint();
			}
		}
		if(element != null){
			if(independent){
				try {
					element.setIndependentProperty(property, guiProperty.parseComponents(property, lines));
				} catch (InstantiationException | IllegalAccessException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			else{
				try {
					element.setDependentProperty(property, guiProperty.parseComponents(property, lines));
				} catch (InstantiationException | IllegalAccessException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}
	}

}
