package org.processmining.plugins.properties.processmodel.gui.impl;

import java.util.ArrayList;
import java.util.List;

import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JTextField;

import org.processmining.plugins.properties.enumerations.QueueType;
import org.processmining.plugins.properties.processmodel.PropertableElement;
import org.processmining.plugins.properties.processmodel.Property;
import org.processmining.plugins.properties.processmodel.gui.abstractguiproperty.AddButton;
import org.processmining.plugins.properties.processmodel.gui.abstractguiproperty.GUIPropertySinglePage;
import org.processmining.plugins.properties.processmodel.impl.SimulationProperty;

import com.fluxicon.slickerbox.factory.SlickerFactory;

/**
 * 
 * @author DSchunse
 *
 */
public class GUIPropertySimulationProperty extends GUIPropertySinglePage<SimulationProperty>{

	public <E extends PropertableElement, P extends Property<?>> void fillGUI(P prop, E element, AddButton button, List<List<JComponent>> dataRows, boolean independent) throws InstantiationException, IllegalAccessException{
		SimulationProperty simprop = null;
		if(independent){
			if(element.getIndependentProperty(prop) != null){
				simprop = (SimulationProperty) element.getIndependentProperty(prop);
			}
		}
		else{
			if(element.getDependentProperty(prop) != null){
				simprop = (SimulationProperty) element.getDependentProperty(prop);
			}
		}
		if(simprop != null){
			((JComboBox)dataRows.get(0).get(0)).setSelectedItem(simprop.getqType());
			((JCheckBox)dataRows.get(0).get(1)).setSelected(simprop.isPush());
			((JCheckBox)dataRows.get(0).get(2)).setSelected(simprop.isPull());
			((JTextField)dataRows.get(0).get(3)).setText("" + simprop.getWarmUpPeriod());
			((JTextField)dataRows.get(0).get(4)).setText("" + simprop.getNrSubRuns());
			((JTextField)dataRows.get(0).get(5)).setText("" + simprop.getLengthOfSubRuns());
		}
		
	}
	
	public <E extends PropertableElement> List<List<JComponent>> getHeaderRows(E element){
		ArrayList<List<JComponent>> header = new ArrayList<List<JComponent>>();
		JLabel lqueue = SlickerFactory.instance().createLabel("QueueType");
		JLabel lPush = SlickerFactory.instance().createLabel("Push");
		JLabel lPull = SlickerFactory.instance().createLabel("Pull");
		JLabel lWarmUp = SlickerFactory.instance().createLabel("Warm-up period");
		JLabel lnrOfReplications = SlickerFactory.instance().createLabel("Nr of Replications");
		JLabel lReplicationLength = SlickerFactory.instance().createLabel("Replication Length");
		ArrayList<JComponent> head = new ArrayList<JComponent>();
		head.add(lqueue);
		head.add(lPush);
		head.add(lPull);
		head.add(lWarmUp);
		head.add(lnrOfReplications);
		head.add(lReplicationLength);
		header.add(head);
		return header;
	}

	public <E extends PropertableElement> List<List<JComponent>> getDataRow(E element) throws InstantiationException, IllegalAccessException{
		List<List<JComponent>> dataRows = new ArrayList<List<JComponent>>();
		List<JComponent> dataRow = new ArrayList<JComponent>();
		dataRow.add(SlickerFactory.instance().createComboBox(QueueType.values()));
		dataRow.add(SlickerFactory.instance().createCheckBox("", true));
		dataRow.add(SlickerFactory.instance().createCheckBox("", false));
		dataRow.add(new JTextField(60));
		dataRow.add(new JTextField(60));
		dataRow.add(new JTextField(60));
		dataRows.add(dataRow);
		return dataRows;
	}

	public <P extends Property<?>> SimulationProperty parseComponents(P property, List<List<List<Object>>> lines) throws InstantiationException, IllegalAccessException{
		SimulationProperty simprop = new SimulationProperty();
		simprop.setqType((QueueType)lines.get(0).get(0).get(0));
		simprop.setPush((Boolean) lines.get(0).get(0).get(1));
		simprop.setWarmUpPeriod(Integer.valueOf((String) lines.get(0).get(0).get(3)));
		simprop.setNrSubRuns(Integer.valueOf((String) lines.get(0).get(0).get(4)));
		simprop.setLengthOfSubRuns(Integer.valueOf((String) lines.get(0).get(0).get(5)));
		return simprop;
	}
	
}
