package org.processmining.plugins.properties.processmodel.impl;

import java.util.HashSet;
import java.util.Set;

import org.processmining.framework.plugin.annotations.KeepInProMCache;
import org.processmining.plugins.properties.annotations.OriginatorPerspective;
import org.processmining.plugins.properties.annotations.PropertableElementProperty;
import org.processmining.plugins.properties.enumerations.Constructs;

/**
 * 
 * @author DSchunse
 *
 */
@KeepInProMCache
@OriginatorPerspective
@PropertableElementProperty
public class AutomaticDistribution extends Distribution{
	private static final long serialVersionUID = -5148631613566217221L;
	
	public AutomaticDistribution(){
		
	}
	
	public AutomaticDistribution(Distribution distr){
		super(distr);
	}
	
	public Long getID() {
		return serialVersionUID;
	}

	public String getName() {
		return "AutomaticDistribution";
	}
	
	public AutomaticDistribution clone(Object element){
		return new AutomaticDistribution((Distribution) element);
	}
	
	public Set<Constructs> getMeaningfulTypeConstructs() {
		Set<Constructs> constructs =  new HashSet<Constructs>();
		constructs.add(Constructs.AutomaticTask);
		return constructs;
	}
	
	public Object unmarshall(String xml){
		return new AutomaticDistribution((Distribution)super.unmarshall(xml));
	}
	
}
