package org.processmining.plugins.properties.processmodel.impl;

import java.util.HashSet;
import java.util.Set;

import org.processmining.framework.plugin.annotations.KeepInProMCache;
import org.processmining.plugins.properties.annotations.OriginatorPerspective;
import org.processmining.plugins.properties.annotations.PropertableElementProperty;
import org.processmining.plugins.properties.enumerations.Constructs;

/**
 * 
 * @author DSchunse
 *
 */
@KeepInProMCache
@OriginatorPerspective
@PropertableElementProperty
public class EventDistribution extends Distribution{
	private static final long serialVersionUID = 8070362200740687215L;

	public EventDistribution(){
		
	}
	
	public EventDistribution(Distribution distr){
		super(distr);
	}
	
	public EventDistribution clone(Object element){
		return new EventDistribution((Distribution) element);
	}
	
	public Long getID() {
		return serialVersionUID;
	}

	public String getName() {
		return "EventDistribution";
	}
	

	public Set<Constructs> getMeaningfulTypeConstructs() {
		Set<Constructs> constructs = new HashSet<Constructs>();
		constructs.add(Constructs.Event);
		return constructs;
	}
	
	public Object unmarshall(String xml){
		return new EventDistribution((Distribution)super.unmarshall(xml));
	}
	
}
