package org.processmining.plugins.properties.processmodel.impl;

import java.util.HashSet;
import java.util.Set;

import org.processmining.framework.plugin.annotations.KeepInProMCache;
import org.processmining.plugins.properties.annotations.ControlFlowPerspective;
import org.processmining.plugins.properties.annotations.PropertableElementProperty;
import org.processmining.plugins.properties.enumerations.Constructs;
import org.processmining.plugins.properties.processmodel.abstractproperty.PropertyDouble;

/**
 * 
 * @author DSchunse
 *
 */
@KeepInProMCache
@PropertableElementProperty
@ControlFlowPerspective
public class LoopCutOffProbability extends PropertyDouble{
	private static final long serialVersionUID = -4403679700844950838L;

	public Long getID() {
		return serialVersionUID;
	}

	public String getName() {
		return "Cut-off Probability for Loops";
	}

	public Double getDefaultValue() {
		return 0d;
	}
	
	public Set<Constructs> getMeaningfulTypeConstructs() {
		Set<Constructs> ret = new HashSet<Constructs>();
		ret.add(Constructs.ExclusiveChoiceLoop);
		ret.add(Constructs.DeferredChoiceLoop);
		return ret;
	}

}
